<?php

require_once 'base/ParcnegocioEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 * @author  Setforms
 */
class ParcnegocioEntity extends ParcnegocioEntityBase
{
    /* alessandrobartels - 09/05/2012 - Constantes usadas no processo de migracao */
    const CDTIPOPARCPRINCIPAL_PESSOA = 'PESSOA';
    const CDTIPOPARCPRINCIPAL_ESTRUTURA = 'ESTRUTURA';
    const CDTIPOINSCRICAO_CPF = 'CPF';
    const CDTIPOINSCRICAO_CNPJ = 'CNPJ';
    const CDTIPOINSCRICAO_LIVRE = 'LIVRE';
    /* --------------------------------------------------------------------------  */

    /**
     * Retorna registros de um determinado Parceiro de Negocio.
     *
     * @param integer $nrparceiro Numero do Parceiro de Negocio.
     * @param integer $nrorg      Numero da Organizacao.
     *
     * @return ParcnegocioEntity
     *
     * @author brunofeliciano - 28/06/2011
     */
    public function retornaParceiroNegocio($nrparceiro, $nrorg){
        return Parcnegocio::consultaParceiroNegocio($nrparceiro, $nrorg);
    }

    /**
     * retorna novo código.
     *
     * @return ParcnegocioEntity
     *
     * @author gustavosilva - 18/05/2012
     */
    public static function geraNovoCodigoParcnegocio(){
        $nrparcnegocio = \Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(),'PARCNEGOCIO',1,12);
        return $nrparcnegocio;

    }

    /**
     * Retorna novo numero de Inscrição.
     *
     * @return number
     *
     * @author gustavosilva - 18/05/2012
     */
    public static function geraNovoCodigoNrInscr(){

        return Parcnegocio::geraNovoCodigoNrInscr();


    }

    /**
     * Retorna numero de inscricaoo do parceiro.
     *
     * @param integer $nrparcnegocio Numero do Parceiro de Negocio.
     * @param integer $nrorg         Numero da Organizacao.
     *
     * @return array
     *
     * @author gustavosilva - 18/05/2012
     */
    public static function selectNrinscricaoParc($nrparcnegocio, $nrorg){

        return Parcnegocio::selectNrinscricaoParc($nrparcnegocio, $nrorg);

    }

    /**
     * Retorna o tamanho em caracteres do numero de inscrição do parceiro.
     *
     * @param integer $nrparcnegocio Numero do Parceiro de Negocio.
     * @param integer $nrorg         Numero da Organizacao.
     *
     * @return array
     *
     * @author gustavosilva - 18/05/2012
     */
    public static function lenghNrInscricaoParc($nrparcnegocio, $nrorg){

        return Parcnegocio::lenghNrInscricaoParc($nrparcnegocio, $nrorg);

    }


    /**
     * Retorna parceiro de negocio por tipo de inscricao(cpf ou cnpj).
     *
     * @param string  $tipoinscricao   Tipo de inscricao.
     * @param integer $nrinscricaoparc Numero de inscricao.
     * @param integer $nrorg           Tipo do parceiro de negocio.
     *
     * @return ParcnegocioEntity
     *
     * @author brunofeliciano - 28/06/2011
     *         thalesvalias - 19/04/2012 - nome da funcao alterada; parametro $tipoinscricao adicionado
     */
    public function retornaParceiroPorInscricao($tipoinscricao, $nrinscricaoparc, $nrorg){
        return Parcnegocio::retornaParceiroPorInscricao($tipoinscricao, $nrinscricaoparc, $nrorg);
    }


    /**
     * Inclui Parceiro de Negocio.
     *
     * @param integer $nrOrg           Numero do Organizacao.
     * @param string  $nmPrincipalParc Nome principal do parceiro.
     * @param string  $nmSecundariParc Nome secundario do parceiro.
     * @param integer $nrInscricaoParc Numero da inscricao do Parceiro.
     * @param string  $cdTipoInscricao Codigo do Tipo de inscricao.
     * @param string  $idAtivo         Id Ativo.
     * @param string  $idPessoaFisica  Id da Pessoa Fisica.
     * @param string  $idInstituicao   Id da Instituicao.
     * @param string  $cdTipoParceiro  Tipo de parceiro.
     * @param string  $dtNascPessoa    Data de nascimento ou fundacao do parceiro.
     *
     * @return boolean
     *
     * @author brunofeliciano - 28/06/2011
     *         thalesvalias - 18/04/2012 - Adicao de parametros e renomeacao das variaveis
     */
    public function incluiParcNegocio($nrOrg, $nmPrincipalParc, $nmSecundariParc, $nrInscricaoParc,$cdTipoInscricao,
                                      $idAtivo, $idPessoaFisica, $idInstituicao, $cdTipoParceiro, $dtNascPessoa){
        try {

            $parcnegocio = new self();
            $parcnegocio->setNrorg($nrOrg);
            $parcnegocio->setNmprincipalparc($nmPrincipalParc);
            $parcnegocio->setNmsecundariparc($nmSecundariParc);
            $parcnegocio->setNrinscricaoparc($nrInscricaoParc);
            $parcnegocio->setIdativo($idAtivo);
            $parcnegocio->setCdtipoinscricao($cdTipoInscricao);
            $parcnegocio->setIdpessoafisica($idPessoaFisica);
            $parcnegocio->setIdinstituicao($idInstituicao);
            $parcnegocio->setCdtipoparcprincipal($cdTipoParceiro);
            $parcnegocio->setDtnascifundparc($dtNascPessoa);
            $parcnegocio->persist();

            // alessandrobartels - 09/05/2012 - Usado posterior a chamada do metodo - Ex.: MigraParceiro.

            $this->setNrparcnegocio($parcnegocio->getNrparcnegocio());
            $this->setNrinscricaoparc($parcnegocio->getNrinscricaoparc());

            return true;
        }
        catch (Exception $e){
            tk_message(' Exception '.$e->getLine().' : '.$e->getTrace().' - '.$e->getMessage());
            return false;
        }
    }

    /**
     * Retorna array com orçamentos do parceiro.
     *
     * @param integer $nrparcnegocio Numero do Parceiro de Negocio.
     * @param integer $nrorg         Numero da Organizacao.
     *
     * @return array
     *
     * @author gustavosilva - 18/05/2012
     */
    public static function consultaOrcamentosDoParceiro($nrparcnegocio, $nrorg){

        return Parcnegocio::consultaOrcamentosDoParceiro($nrparcnegocio, $nrorg);

    }


    /**
     * Retorna a consulta de Parceiros de negocio com parceria de operador.
     *
     * @return Mixed <$sql, string>
     */
    public static function buscaParceirosOperadores(){
        $dados = Parcnegocio::buscaParceirosOperadores();
        return $dados;

    }


    /**
     * Retorna Parceiro de Neg?s por tipo de parceiro principal.
     *
     * @param string $nrparceiro N?o do Parceiro de Neg?.
     * @param string $nrorg      N?o da Organiza?.
     * @param string $tipo_parc  Tipo Principal do Parceiro.
     *
     * @return Mixed<NULL, ParcnegocioEntity>
     */
    public static function retornaParceiroPorTipo($nrparceiro, $nrorg, $tipo_parc = null){
        return Parcnegocio::retornaParceiroPorTipo($nrparceiro, $nrorg, $tipo_parc);
    }

    public static function retornaInterlocutor($nrparc, $nrorg, $nrparcrelac)
    {
        $row = Parcnegocio::consultaInterlocutor($nrparc, $nrorg, $nrparcrelac);
        if (empty($row) === true) {
            return null;
        } else {
            unset($row[0]['NRPARCNEGRELAC']);
            $obj = new self();
            foreach($row[0] as $col => $val) {
                $set = 'set'.ucfirst(strtolower($col));
                $obj->$set($val);
            }

            return $obj;
        }
    }

    public function filtroAssistente($selectTipoParceiro, $innerTipoParceiro, $where)
    {

        $select = Parcnegocio::filtroAssistente($selectTipoParceiro, $innerTipoParceiro, $where);
        return $select;

    }

    public function setParceiro($nrOrg, $idativo, $nmPrincipalParc, $nmSecundariParc, $nrInscricaoParc, $cdTipoInscricao,
                                   $idPessoaFisica, $idInstituicao, $cdTipoParceiro, $dtnascifundparc)
    {
        $this->setNrorg($nrOrg);
        $this->setIdativo($idativo);
        $this->setNmprincipalparc($nmPrincipalParc);
        $this->setNmsecundariparc($nmSecundariParc);
        $this->setNrinscricaoparc($nrInscricaoParc);
        $this->setCdtipoinscricao($cdTipoInscricao);
        $this->setIdpessoafisica($idPessoaFisica);
        $this->setIdinstituicao($idInstituicao);
        $this->setCdtipoparcprincipal($cdTipoParceiro);
        $this->setDtnascifundparc($dtnascifundparc);
    }

    public static function getByNrorgCnpjNomeDtnascimento($nrorg, $nrinscricaoparc, $nmprincipalparc, $dtnascifundparc) {
        $parcnegocio = self::getEntityByWhere(
            'NRORG = ? AND NRINSCRICAOPARC = ? AND NMPRINCIPALPARC = ? AND DTNASCIFUNDPARC = ?',
            array($nrorg, $nrinscricaoparc, $nmprincipalparc, $dtnascifundparc)
        );
        return $parcnegocio;
    }

}