function est46000_EmissaoAjusteInventario_Controller(General, ScreenService, restEngine, maskEngine, ZhUtil, templateManager, localStorageEngine, ZhReports, ProductField, Est46000_EmissaoAjusteInventario_Service, Est31300_MovimentacaodeEstoque_Service) {

    this.defaultValueEmissaoAjuste = function(args){
        var formWidget = args.owner;
        args.row.REPORT_NAME = 'EST46000';
        args.row.DTPERINI    = moment().startOf('month').format('DD/MM/YYYY');
        args.row.DTPERFIN    = moment().endOf('month').format('DD/MM/YYYY');
        args.row.CUSTOS      = 1;
        args.row.NRORG       = getLocalVar('ERP_NRORGTRAB')||getLocalVar('NRORGTRAB');
        args.row.ORDENA      = 1;
        
        var campoNivel = formWidget.getField('NPTOTALIZA');
        var levels  = General.getLevelByMask('GER_CDPICTPROD', 1);
        campoNivel.dataSource.data = [];
        for (var index in levels) {
            campoNivel.dataSource.data.push(
                {
                    "name": levels[index].nivel,
                    "value": levels[index].caracteres
                }
            );
        }

        campoNivel.setValue(campoNivel.dataSource.data[0].value);
        
        this.getFilialLogada().then( success => {
            args.row.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            args.row.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            var widget = templateManager.container.getActiveWidget();
            let currentRow = widget.currentRow;
            
                widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil){
                    if(fil.name == "CDFILIAL"){
                        fil.value = currentRow.CDFILIAL; 
                    }
                });
                widget.getField('DSLOCALESTOQ').dataSourceFilter.forEach(function(fil){
                    if(fil.name == "CDFILIAL"){
                        fil.value = currentRow.CDFILIAL; 
                    }
                });
                widget.getField('DSALMOXARIFE').reload();
                widget.getField('DSLOCALESTOQ').reload();
                this.checkUnidadeFields(widget);
        }); 
    };
    
    this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.geraRelatorio = function(widget,type){//receber em type xls ou pdf
        var REPORT_JSON = "./json/reports/est46001_relatorio.json";
        
        ScreenService.showLoader();
        restEngine.requestMetaData(REPORT_JSON).then(function(reportMetaData){
            ScreenService.hideLoader();
            ZhReports.openReport(reportMetaData.data, widget,null,null,type);
        });
    };

    this.validaData = function(currentRow) {

        var dataInicial = currentRow.DTPERINI ? moment(currentRow.DTPERINI, 'DD/MM/YYYY')._d : null;
        var dataFinal = currentRow.DTPERFIN ? moment(currentRow.DTPERFIN, 'DD/MM/YYYY')._d : null;
        var mensagem = "A data final deve ser menor ou igual a data final.";

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
    };

    this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };

    this.validaNivel = function(currentRow) {
        var mensagem = "O produto final não pode ser maior que o inicial.";
        var retorno = '';

        if(currentRow.CDARVPRODINI && currentRow.CDARVPRODFIN) {
            retorno = this.comparaPratoProduto(currentRow.CDARVPRODINI, currentRow.CDARVPRODFIN, getLocalVar('CDPICTPROD'));
            if (!retorno) {
                ScreenService.showMessage(mensagem);
                return false;
            }
            return true;
        }
        return false;
    };

    this.validaRelatorioGrid = function(currentRow, widget) {
        if (widget.isValid() && this.validaData(currentRow) && this.validaNivel(currentRow)) {
            var rowStripe = {};
            rowStripe.DSFILIAL = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
            rowStripe.DSPRODUTO = currentRow.CDARVPRODINI + ' à ' + currentRow.CDARVPRODFIN;
            rowStripe.DSPERIODO= currentRow.DTPERINI + ' à ' + currentRow.DTPERFIN;
            rowStripe.CUSTOS = currentRow.CUSTOS;
            localStorageEngine.setDataSource('/StripeEmissao', rowStripe);
            currentRow.CDPRODFIN = currentRow.CDARVPRODFIN + "zzzzzzzzzzzzzzzzzzzz";
            currentRow.CDPRODFIN = currentRow.CDPRODFIN.substring(0, 20);
            return restEngine.post('est_relatorios#/emissao_ajuste', {
                "requestType": "Row",
                "row": currentRow
            }).then(function(callback) {
                var datasetEmissao = callback.dataset.EmissaoAjuste;
                if (datasetEmissao.length) {
                    localStorageEngine.setDataSource('est_relatorios#/emissao_ajuste', datasetEmissao).then(function(){
                        ScreenService.openWindow('est_relatorios#est46001_grid_relatorio_ajuste');
                    });
                } else {
                    ScreenService.showMessage('Não há dados a serem listados!');
                }

            });
        }
    };
    
    this.validateBirthReport = function(widget, format) {
        var currentRow  = widget.currentRow;
        currentRow.__format = format;
        if(!currentRow.CDPRODFIN)
            currentRow.CDPRODFIN = currentRow.CDARVPRODFIN;
            
        var compproduto = (currentRow.CDPRODFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

        if (widget.isValid()) {
            if(General.comparaPratoProduto(currentRow.CDARVPRODINI, compproduto, getLocalVar('GER_CDPICTPROD'))) {
                if(currentRow.REPORT_NAME == 'GRID'){
                    this.validaRelatorioGrid(currentRow, widget);
                }
                else{
                    Est46000_EmissaoAjusteInventario_Service.requestReport(currentRow).then(function(birtURL){
                        window.open(birtURL.dataset.URL[0]);
                    });
                }
            } else {
                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        }
    };

    this.onEnterRelatorio = function(){
        var container = templateManager.container;
        var stripe = container.getWidget('stripe');
        localStorageEngine.getDataSource('/StripeEmissao').then(function(row){
            stripe.currentRow.DSFILIAL = row[0].DSFILIAL;
            stripe.currentRow.DSPERIODO = row[0].DSPERIODO;
            stripe.currentRow.DSPRODUTO = row[0].DSPRODUTO;
            if(row[0].CUSTOS=='1'){
                stripe.currentRow.CUSTOS = 'Líquido';
            }else{
                stripe.currentRow.CUSTOS = 'Bruto';
            }
        });
    };

    var applyMask = function(fieldValue, maxlength) {
        var mask = {
            "type": "zerofill",
            "params": {
                "right": true,
                "maxlength": maxlength
            }
        };
        return Util.applyMask(fieldValue, mask, maskEngine, ZhUtil);
    };
    
    this.fieldOnChangeRelatorio = function(widget) {
        if(widget.currentRow.REPORT_NAME === 'GRID') {
            widget.getField('NPTOTALIZA').readOnly             = true;
            widget.currentRow.NPTOTALIZA                       = 1;
            widget.getField('NPTOTALIZA').validations          = {"required": false};
        }else{
            widget.getField('NPTOTALIZA').readOnly          = false;
            widget.getField('NPTOTALIZA').validations       = {"required": true};
        }
        widget.reload();
    };
    
    this.checkUnidadeFields = function(widget) {
        var currentRow = widget.currentRow;

        ProductField.updateProductFilters(widget);
        if(currentRow.REPORT_NAME === 'EST46000' || currentRow.REPORT_NAME === 'GRID') {
            if(currentRow.CDFILIAL) {
                Est31300_MovimentacaodeEstoque_Service.requestValidations(currentRow.CDFILIAL).then(function(checks) {
                    currentRow.ALMOXARIFADO = checks.IDUTILALMOX;
                    currentRow.LOCALESTOQUE = checks.IDUTILLCESTQ;
                    currentRow.LOTE         = checks.IDUTILLOTE;

                    var almoxarifado = widget.getField('DSALMOXARIFE');
                    var localestoque = widget.getField('DSLOCALESTOQ');
                    var lote = widget.getField('NRLOTEESTQ');

                    if(currentRow.LOTE) {
                        lote.dataSourceFilter[1] = {"name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL};
                        lote.readOnly            = false;
                        currentRow.NRLOTEESTOQ = null;
                        
                        this.reloadFields(widget, false, false, true);
                    } else {
                        lote.readOnly    = true;
                        currentRow.NRLOTEESTOQ = " ";
                    }
                    if(currentRow.ALMOXARIFADO) {
                        almoxarifado.dataSourceFilter[0] = {"name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL};
                        almoxarifado.readOnly            = false;
                        almoxarifado.validations         = {"required": true};
                        this.reloadFields(widget, true, false, false);
                        
                        if(currentRow.LOCALESTOQUE) {
                            localestoque.dataSourceFilter[0] = {"name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL};
                            localestoque.validations         = {"required": true};

                            this.checkAlmoxariFields(widget, true);
                        } else {
                            localestoque.readOnly    = true;
                            localestoque.validations = null;
                        }
                    } else {
                        almoxarifado.readOnly    = true;
                        almoxarifado.validations = null;

                        localestoque.readOnly    = true;
                        localestoque.validations = null;
                    }

                }.bind(this));
            } else {
                currentRow.ALMOXARIFADO = false;
                currentRow.LOCALESTOQUE = false;
                currentRow.NRLOTEESTOQ  = false;

                widget.getField('DSALMOXARIFE').readOnly = true;
                widget.getField('DSLOCALESTOQ').readOnly = true;
                widget.getField('NRLOTEESTQ').readOnly    = true;

                widget.getField('DSALMOXARIFE').validations = null;
                widget.getField('DSLOCALESTOQ').validations = null;
                widget.getField('NRLOTEESTQ').validations    = null;

                this.reloadFields(widget, true, true, true);
            }
        }
    };
    
    this.reloadFields = function(widget, almoxarifado, localestoque, lote) {
        var currentRow = widget.currentRow;

        if(almoxarifado) {
            currentRow.CDALMOXARIFE = (currentRow.ALMOXARIFADO)? null : ' ';
            currentRow.DSALMOXARIFE = (currentRow.ALMOXARIFADO)? null : ' ';

            widget.getField('DSALMOXARIFE').reload();
        }

        if(localestoque) {
            currentRow.CDLOCALESTOQ = (currentRow.LOCALESTOQUE)? null : ' ';
            currentRow.DSLOCALESTOQ = (currentRow.LOCALESTOQUE)? null : ' ';

            widget.getField('DSLOCALESTOQ').reload();
        }

        if(lote) {
            currentRow.NRLOTEESTQ = null;
            currentRow.NRSUBLOTE = null;

            widget.getField('NRLOTEESTQ').reload();
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est46000_EmissaoAjusteInventario_Controller', est46000_EmissaoAjusteInventario_Controller);
});